
class User:
    def __init__(self):
        self.user_full_name = ""
        self.user_first_name = ""
        self.user_last_name = ""
        self.user_email = ""
        self.user_start_date = ""
        self.user_employee_type = ""
        self.user_title = ""
        self.user_department = ""
        self.user_location = ""
        self.user_office = ""
        self.user_supervisor = ""
        self.user_approval_group = ""
        self.user_phone_number = ""
        self.user_group_membership = []

    def get_user(self):
        import pandas as pd
        from json import dump
        from re import findall
        """
        Prompts operator for .xlsx file from HR
        Populates Main.__init__() data
        Outputs data from xlsx file to JSON file
        :return:
        """
        # todo Prompt user for excel file
        # todo Check excel file / error handling for bad excel file
        # todo Add error handling for PowerShell Execution Policy exception
        # todo Build GUI

        data = pd.read_excel(r'C:\Users\cameron\Desktop\Group Membership\testy.xlsx', sheet_name="Sheet1")

        full_name = pd.DataFrame(data, index=[1], columns=["Unnamed: 1"])
        email = pd.DataFrame(data, index=[2], columns=["Unnamed: 1"])
        start_date = pd.DataFrame(data, index=[3], columns=["Unnamed: 1"])
        employee_type = pd.DataFrame(data, index=[4], columns=["Unnamed: 1"])
        title = pd.DataFrame(data, index=[5], columns=["Unnamed: 1"])
        department = pd.DataFrame(data, index=[6], columns=["Unnamed: 1"])
        location = pd.DataFrame(data, index=[7], columns=["Unnamed: 1"])
        office = pd.DataFrame(data, index=[8], columns=["Unnamed: 1"])
        supervisor = pd.DataFrame(data, index=[9], columns=["Unnamed: 1"])
        approval_group = pd.DataFrame(data, index=[10], columns=["Unnamed: 1"])

        printable_value = lambda x: x.values[0][0]

        self.user_full_name = printable_value(full_name)
        self.user_first_name = findall(r"^[a-zA-Z\-]*", self.user_full_name)[0]
        self.user_last_name = findall(r"[a-zA-Z\-]*\Z", self.user_full_name)[0]
        self.user_email = printable_value(email)
        self.user_start_date = printable_value(start_date).strftime("%d/%m/%Y")
        self.user_employee_type = printable_value(employee_type)
        self.user_title = printable_value(title)
        self.user_department = printable_value(department)
        self.user_location = printable_value(location)
        self.user_office = printable_value(office)
        self.user_supervisor = printable_value(supervisor)
        self.user_approval_group = printable_value(approval_group)

        output = dict(full_name=self.user_full_name,
                      first_name=self.user_first_name,
                      last_name=self.user_last_name,
                      email=self.user_email,
                      start_date=self.user_start_date,
                      employee_type=self.user_employee_type,
                      user_title=self.user_title,
                      user_department=self.user_department,
                      user_location=self.user_location,
                      user_office=self.user_office,
                      user_supervisor=self.user_supervisor,
                      user_approval_group=self.user_approval_group)

        # todo prompt user for output file path / set path variable as parent class property

        with open("C:\\Users\Cameron\Documents\output.json", "w") as write_file:
            dump(output, write_file)

    def create_user(self):
        """
        Will run a PS script that creates an domain or local account (depending on target)
        Depending on the target, different arguments for the PS script will be fed
        :param target: cmgl.ca, inet, printsvr3, printsvr-cti
        :return:
        """
        from subprocess import Popen
        from sys import stdout
        ps_script = r"C:\Scripts\Create-CMGLUser.ps1"
        print(ps_script)
        filename = r'C:\Users\cameron\Documents\output.json'
        p = Popen(
                 [r'C:\Windows\SysWOW64\WindowsPowerShell\v1.0\powershell.exe', "-noprofile",  "-File", ps_script,
                  '-FilePath:', filename], stdout=stdout
                 )
        p.communicate()

    def provsion_groups(self):
        """
        Will run a PS script that adds groups based off of a similar user's group membership
        :return:
        """
        from subprocess import Popen
        from sys import stdout
        ps_script = r"C:\Scripts\Don't load into profile\Set-CMGGroupMembership.ps1"
        print(ps_script)
        filename = r'C:\Users\cameron\Documents\output.json'
        p = Popen(
            [r'C:\Windows\SysWOW64\WindowsPowerShell\v1.0\powershell.exe', "-noprofile", "-File", ps_script,
             '-FilePath:', filename], stdout=stdout
        )
        p.communicate()

    def provsion_mailbox(self):
        """
        Will run a PS script that creates an Exchange mailbox based on the user details in the spreadsheet
        :return:
        """
        from subprocess import Popen
        from sys import stdout
        ps_script = r"C:\Scripts\Don't load into profile\Create-CMGUserMailbox.ps1"
        print(ps_script)
        filename = r'C:\Users\cameron\Documents\output.json'
        p = Popen(
            [r'C:\Windows\SysWOW64\WindowsPowerShell\v1.0\powershell.exe', "-noprofile", "-File", ps_script,
             '-FilePath:', filename], stdout=stdout
        )
        p.communicate()


def main():
    usr = User()
    usr.get_user()
    usr.create_user()
    usr.provsion_groups()
    usr.provsion_mailbox()


if __name__ == "__main__":
    main()
